﻿using COM;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;

namespace MyCOMObj
{
    [Guid(MyClassFactory.CLSID)]
    public class MyClassFactory : IClassFactory
    {
        public const string CLSID = "C0000000-71EB-43A6-9BD1-5770A3737617";
        public static string CLSID_KEY
        {
            get
            {
                return new Guid(CLSID).ToString("B");
            }
        }

        public int CreateInstance(IntPtr pUnkOuter, ref Guid riid, out IntPtr ppvObject)
        {
            ppvObject = IntPtr.Zero;

            if (pUnkOuter != IntPtr.Zero)
            {
                return -2147221232; // 2147221232 == 0x80040110 == CLASS_E_NOAGGREGATION;
            }

            string riidText = riid.ToString().ToUpper();

            switch (riidText)
            {
                case "82996B14-75F2-41FC-86A3-14C13DDD7A2C":
                case "00020400-0000-0000-C000-000000000046": // IDispatch
                case "00000000-0000-0000-C000-000000000046": // IUnknown
                    ppvObject = Marshal.GetComInterfaceForObject(new MySimpleObject(), typeof(IMySimpleObject));
                    break;

                default:
                    return -2147467262; // -2147467262 == 0x80004002 == E_NOINTERFACE
            }            

            return 0;
        }

        public int LockServer(bool fLock)
        {
            return 1;
        }
    }
}
